=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR := obj-$(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_UPSTREAM_DEBIAN=1

%:
	dh $@ --with bash-completion

override_dh_auto_configure:
	dh_auto_configure --sourcedir=src -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install
	# man pages
	mkdir -p debian/libxrt-utils/usr/share/man/man1
	# doesn't work for xrt-runner xrt-smi xrt-tracer
	for bin in xclbinutil xrt-replay; do \
	  LD_LIBRARY_PATH=debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE) help2man debian/tmp/usr/bin/$$bin > debian/libxrt-utils/usr/share/man/man1/$$bin.1; \
	done

override_dh_auto_test:
	make -C $(BUILDDIR) install DESTDIR=`pwd`/$(BUILDDIR) # xrt-smi and xbmgmt tests require install
	dh_auto_test
